<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import {
  CTA as CallToAction,
  Copy,
  CopyMedia,
  CopyResources,
  FeaturedMedia,
  NextStep,
  SlpBreadcrumb,
  Table as SlpTable,
} from '../../../components/common/index.vue';
import {
  CompanyCopyCard as CopyCard,
  CopyMediaCard,
} from '../../../components/company/index.vue';
import {
  BenefitsIcons,
  TopicsCards,
  TopicsCopyBlock,
  TopicsCta,
  TopicsEmphasis,
  TopicsHeader,
  TopicsInfoTable,
} from '../../../components/topics/index.vue';
import {
  fetchTopicBySlug,
  handleTopicFromContentful,
} from '~/services/topics-contentful.js';

import { SolutionsResourceCards } from '~/components/solutions/index.vue';
import { getPageMetadata } from '~/common/meta';

export default Vue.extend({
  components: {
    CallToAction,
    Copy,
    CopyResources,
    CopyCard,
    CopyMediaCard,
    CopyMedia,
    TopicsCards,
    TopicsCta,
    BenefitsIcons,
    TopicsHeader,
    FeaturedMedia,
    SlpTable,
    SlpBreadcrumb,
    TopicsCopyBlock,
    SolutionsResourceCards,
    TopicsInfoTable,
    TopicsEmphasis,
    NextStep,
  },
  nuxtI18n: false,
  async asyncData({ params }: any) {
    try {
      let contentfulData;
      if (!params.slug) {
        contentfulData = await fetchTopicBySlug('devsecops');
      } else {
        contentfulData = await fetchTopicBySlug(`devsecops/${params.slug}`);
      }

      if (!contentfulData) {
        throw new Error('No Contentful data on /topics/devsecops/_slug');
      }
      const document = handleTopicFromContentful(contentfulData);

      return { document };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).document, this.$route.path);
  },
});
</script>

<template>
  <div>
    <SlpContainer>
      <div v-if="document.sideMenu">
        <SlpBreadcrumb class="slp-mt-32" :crumbs="document.crumbs" />
        <TopicsHeader
          v-if="document.topicsHeader"
          :data="document.topicsHeader.data"
        />
        <OldTopicsHeader
          v-if="document.old_topicsHeader"
          :data="document.old_topicsHeader.data"
        />
        <SlpSideNavigation
          :data="document.sideMenu"
          :class="{
            'side-navigation--w-hero': document.topicsHeader,
            'side-navigation--w-old-hero': document.old_topicsHeader,
          }"
        >
          <template v-if="document.sideMenu.hyperlinks" #footer>
            <div>
              <SlpTypography
                v-show="document.sideMenu.hyperlinks.text"
                tag="div"
                variant="body3-bold"
                class="nav-heading"
                >{{ document.sideMenu.hyperlinks.text }}</SlpTypography
              >
              <SlpButton
                v-for="(button, buttonIndex) in document.sideMenu.hyperlinks
                  .data"
                :key="buttonIndex"
                class="hyperlinks"
                :variant="button.variant"
                :href="button.href"
                :data-ga-name="button.data_ga_name"
                :data-ga-location="button.data_ga_location"
                >{{ button.text }}
                <SlpIcon
                  v-if="button.icon"
                  class="slp-ml-8"
                  name="chevron-lg-right"
                  variant="product"
                  alt="Chevron Right Icon"
                />
              </SlpButton>
            </div>
          </template>
          <component
            :is="component.name"
            v-for="(component, index) in document.sideMenu.content"
            :key="component.name + `-${index}`"
            :data="component.data"
          />
        </SlpSideNavigation>
      </div>
      <component
        :is="component.name"
        v-for="component in document.components"
        :key="component.name"
        :data="component.data"
      />
    </SlpContainer>
    <SlpContainer variant="gradient">
      <NextStep disable-animations />
    </SlpContainer>
  </div>
</template>
<style lang="scss" scoped>
:deep .dropdown {
  margin: $spacing-32 0;
}
:deep #collapsible-sidebar {
  overflow-y: scroll;
  max-height: calc(100vh - $spacing-96);
  height: 100%;
}
.side-navigation--w-old-hero {
  :deep #collapsible-sidebar {
    padding-top: 0 !important;
  }
}
.side-navigation--w-hero {
  :deep #collapsible-sidebar {
    margin-top: $spacing-96;
  }
}
.hyperlinks {
  font-size: $font-size-default;
  line-height: 20px;
  font-weight: $font-weight-normal;
  text-align: left !important;
}
.nav-heading {
  margin-bottom: $spacing-8;
}
</style>
